Index: palm/trunk/SOURCE/urban_surface_mod.f90
===================================================================
--- palm/trunk/SOURCE/urban_surface_mod.f90	(revision 2008)
+++ palm/trunk/SOURCE/urban_surface_mod.f90	(revision 2011)
@@ -3113,90 +3675,249 @@
     END SUBROUTINE usm_read_urban_surface_types
 
- 
+
 !------------------------------------------------------------------------------!
 ! Description:
 ! ------------
-!
-!> This subroutine is part of the urban surface model.
-!> It reads daily heat produced by anthropogenic sources
-!> and the diurnal cycle of the heat.
-!------------------------------------------------------------------------------!
-    SUBROUTINE usm_read_anthropogenic_heat
-    
-        INTEGER(iwp)                  :: i,j,ii
-        REAL(wp)                      :: heat
-        
-        !-- allocation of array of sources of anthropogenic heat and their diural profile
-        ALLOCATE( aheat(nys:nyn,nxl:nxr) )
-        ALLOCATE( aheatprof(0:24) )
-
-        !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
-        !-- read daily amount of heat and its daily cycle
-        !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
-        aheat = 0.0_wp
-        DO  ii = 0, io_blocks-1
-            IF ( ii == io_group )  THEN
-
-                !-- open anthropogenic heat file 
-                OPEN( 151, file='ANTHROPOGENIC_HEAT'//TRIM(coupling_char), action='read', &
-                           status='old', form='formatted', err=11 )
-                i = 0
-                j = 0
-                DO
-                    READ( 151, *, err=12, end=13 )  i, j, heat
-                    IF ( i >= nxl .AND. i <= nxr .AND. j >= nys .AND. j <= nyn ) THEN
-                        !-- write heat into the array
-                        aheat(j,i) = heat
-                    ENDIF
-                    CYCLE
- 12                 WRITE(message_string,'(a,2i4)') 'error in file ANTHROPOGENIC_HEAT'//TRIM(coupling_char)//' after line ',i,j
-                    CALL message( 'usm_read_anthropogenic_heat', 'PA0515', 0, 1, 0, 6, 0 )
-                ENDDO
- 13             CLOSE(151)
-                CYCLE
- 11             message_string = 'file ANTHROPOGENIC_HEAT'//TRIM(coupling_char)//' does not exist'
-                CALL message( 'usm_read_anthropogenic_heat', 'PA0516', 1, 2, 0, 6, 0 )
+!> Solver for the energy balance at the ground/roof/wall surface.
+!> It follows basic ideas and structure of lsm_energy_balance
+!> with many simplifications and adjustments.
+!> TODO better description
+!------------------------------------------------------------------------------!
+    SUBROUTINE usm_surface_energy_balance
+
+        IMPLICIT NONE
+
+        INTEGER(iwp)                          :: i, j, k, l, d      !< running indices
+        
+        REAL(wp)                              :: pt1                !< temperature at first grid box adjacent to surface
+        REAL(wp)                              :: u1,v1,w1           !< near wall u,v,w
+        REAL(wp)                              :: stend              !< surface tendency
+        REAL(wp)                              :: coef_1             !< first coeficient for prognostic equation
+        REAL(wp)                              :: coef_2             !< second  coeficient for prognostic equation
+        REAL(wp)                              :: rho_cp             !< rho_wall_surface * cp
+        REAL(wp)                              :: r_a                !< aerodynamic resistance for horizontal and vertical surfaces
+        REAL(wp)                              :: f_shf              !< factor for shf_eb
+        REAL(wp)                              :: lambda_surface     !< current value of lambda_surface (heat conductivity between air and wall)
+        REAL(wp)                              :: Ueff               !< effective wind speed for calculation of heat transfer coefficients
+        REAL(wp)                              :: httc               !< heat transfer coefficient
+        REAL(wp), DIMENSION(nzub:nzut)        :: exn                !< value of the Exner function in layers
+        
+        REAL(wp), DIMENSION(0:4)              :: dxdir              !< surface normal direction gridbox length
+        REAL(wp)                              :: dtime              !< simulated time of day (in UTC)
+        INTEGER(iwp)                          :: dhour              !< simulated hour of day (in UTC)
+        REAL(wp)                              :: acoef              !< actual coefficient of diurnal profile of anthropogenic heat
+
+        dxdir = (/dz,dy,dy,dx,dx/)
+        
+        exn(:) = (hyp(nzub:nzut) / 100000.0_wp )**0.286_wp          !< Exner function
+            
+!--    
+        DO l = startenergy, endenergy
+!--         Calculate frequently used parameters
+            d = surfl(id,l)
+            k = surfl(iz,l)
+            j = surfl(iy,l)
+            i = surfl(ix,l)
+
+!--         TODO - how to calculate lambda_surface for horizontal surfaces
+!--         (lambda_surface is set according to stratification in land surface model)
+            IF ( ol(j,i) >= 0.0_wp )  THEN
+                lambda_surface = lambda_surf(l)
+            ELSE
+                lambda_surface = lambda_surf(l)
             ENDIF
             
-#if defined( __parallel ) && ! defined ( __check )
-            CALL mpi_barrier( comm2d, ierr )
-#endif
-        ENDDO
-        
-        !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
-        !-- read diurnal profiles of heat sources
-        !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
-        aheatprof = 0.0_wp
-        DO  ii = 0, io_blocks-1
-            IF ( ii == io_group )  THEN
-
-                !-- open anthropogenic heat profile file 
-                OPEN( 151, file='ANTHROPOGENIC_HEAT_PROFILE'//TRIM(coupling_char), action='read', &
-                           status='old', form='formatted', err=21 )
-                i = 0
-                DO
-                    READ( 151, *, err=22, end=23 )  i, heat
-                    IF ( i >= 0 .AND. i <= 24 ) THEN
-                        ! write heat into the array
-                        aheatprof(i) = heat
-                    ENDIF
-                    CYCLE
- 22                 WRITE(message_string,'(a,i4)') 'error in file ANTHROPOGENIC_HEAT_PROFILE'// &
-                                                     TRIM(coupling_char)//' after line ',i
-                    CALL message( 'usm_read_anthropogenic_heat', 'PA0517', 0, 1, 0, 6, 0 )
-                ENDDO
-                aheatprof(24) = aheatprof(0)
- 23             CLOSE(151)
-                CYCLE
- 21             message_string = 'file ANTHROPOGENIC_HEAT_PROFILE'//TRIM(coupling_char)//' does not exist'
-                CALL message( 'usm_read_anthropogenic_heat', 'PA0518', 1, 2, 0, 6, 0 )
+            pt1  = pt(k,j,i)
+
+!--         calculate rho * cp coefficient at surface layer
+            rho_cp  = cp * hyp(k) / ( r_d * pt1 * exn(k) )
+
+!--         calculate aerodyamic resistance. 
+            IF ( d == iroof )  THEN
+!--             calculation for horizontal surfaces follows LSM formulation
+!--             pt, us, ts are not available for the prognostic time step,
+!--             data from the last time step is used here.
+                
+                r_a = (pt1 - t_surf(l)/exn(k)) / (ts(j,i) * us(j,i) + 1.0E-10_wp)
+                
+!--             make sure that the resistance does not drop to zero
+                IF ( ABS(r_a) < 1.0E-10_wp )  r_a = 1.0E-10_wp
+                
+!--             the parameterization is developed originally for larger scales
+!--             (compare with remark in TUF-3D)
+!--             our first experiences show that the parameterization underestimates
+!--             r_a in meter resolution.
+!--             temporary solution - multiplication by magic constant :-(.
+                r_a = r_a * ra_horiz_coef
+                
+!--             factor for shf_eb
+                f_shf  = rho_cp / r_a
+            ELSE
+!--             calculation of r_a for vertical surfaces
+!--
+!--             heat transfer coefficient for forced convection along vertical walls
+!--             follows formulation in TUF3d model (Krayenhoff & Voogt, 2006)
+!--            
+!--             H = httc (Tsfc - Tair)
+!--             httc = rw * (11.8 + 4.2 * Ueff) - 4.0
+!--            
+!--                   rw: wall patch roughness relative to 1.0 for concrete
+!--                   Ueff: effective wind speed
+!--                   - 4.0 is a reduction of Rowley et al (1930) formulation based on
+!--                   Cole and Sturrock (1977)
+!--            
+!--                   Ucan: Canyon wind speed
+!--                   wstar: convective velocity
+!--                   Qs: surface heat flux
+!--                   zH: height of the convective layer
+!--                   wstar = (g/Tcan*Qs*zH)**(1./3.)
+                
+!--             staggered grid needs to be taken into consideration
+                IF ( d == inorth )  THEN
+                    u1 = (u(k,j,i)+u(k,j,i+1))*0.5_wp
+                    v1 = v(k,j+1,i)
+                ELSE IF ( d == isouth )  THEN
+                    u1 = (u(k,j,i)+u(k,j,i+1))*0.5_wp
+                    v1 = v(k,j,i)
+                ELSE IF ( d == ieast )  THEN
+                    u1 = u(k,j,i+1)
+                    v1 = (v(k,j,i)+v(k,j+1,i))*0.5_wp
+                ELSE IF ( d == iwest )  THEN
+                    u1 = u(k,j,i)
+                    v1 = (v(k,j,i)+v(k,j+1,i))*0.5_wp
+                ELSE
+                    STOP
+                ENDIF
+                w1 = (w(k,j,i)+w(k-1,j,i))*0.5_wp
+                
+                Ueff = SQRT(u1**2 + v1**2 + w1**2)
+                httc = roughness_wall(l) * (11.8 + 4.2 * Ueff) - 4.0
+                f_shf  = httc
+            ENDIF
+        
+!--         add LW up so that it can be removed in prognostic equation
+            rad_net_l(l) = surfinsw(l) - surfoutsw(l) + surfinlw(l) - surfoutlw(l)
+
+!--         numerator of the prognostic equation
+            coef_1 = rad_net_l(l) +    &    ! coef +1 corresponds to -lwout included in calculation of radnet_l
+                     (3.0_wp+1.0_wp) * emiss_surf(l) * sigma_sb * t_surf(l) ** 4 +      &  
+                     f_shf  * pt1 +                                                     &
+                     lambda_surface * t_wall(nzb_wall,l)
+
+!--         denominator of the prognostic equation
+            coef_2 = 4.0_wp * emiss_surf(l) * sigma_sb * t_surf(l) ** 3                 &
+                         + lambda_surface + f_shf / exn(k)
+
+!--         implicit solution when the surface layer has no heat capacity,
+!--         otherwise use RK3 scheme.
+            t_surf_p(l) = ( coef_1 * dt_3d * tsc(2) + c_surface(l) * t_surf(l) ) /      & 
+                              ( c_surface(l) + coef_2 * dt_3d * tsc(2) ) 
+
+!--         add RK3 term
+            t_surf_p(l) = t_surf_p(l) + dt_3d * tsc(3) * tt_surface_m(l)
+            
+!--         calculate true tendency
+            stend = (t_surf_p(l) - t_surf(l) - dt_3d * tsc(3) * tt_surface_m(l)) / (dt_3d  * tsc(2))
+
+!--         calculate t_surf tendencies for the next Runge-Kutta step
+            IF ( timestep_scheme(1:5) == 'runge' )  THEN
+                IF ( intermediate_timestep_count == 1 )  THEN
+                    tt_surface_m(l) = stend
+                ELSEIF ( intermediate_timestep_count <                                  &
+                         intermediate_timestep_count_max )  THEN
+                    tt_surface_m(l) = -9.5625_wp * stend + 5.3125_wp                    &
+                                       * tt_surface_m(l)
+                ENDIF
+            ENDIF
+
+!--         in case of fast changes in the skin temperature, it is required to
+!--         update the radiative fluxes in order to keep the solution stable
+            IF ( ABS( t_surf_p(l) - t_surf(l) ) > 1.0_wp )  THEN
+               force_radiation_call_l = .TRUE.
             ENDIF
             
-#if defined( __parallel ) && ! defined ( __check )
-            CALL mpi_barrier( comm2d, ierr )
+!--         for horizontal surfaces is pt(nzb_s_inner(j,i),j,i) = pt_surf.
+!--         there is no equivalent surface gridpoint for vertical surfaces.
+!--         pt(k,j,i) is calculated for all directions in diffusion_s
+!--         using surface and wall heat fluxes
+            IF ( d == iroof )  THEN
+               pt(nzb_s_inner(j,i),j,i) = t_surf_p(l) / exn(k)
+            ENDIF
+
+!--         calculate fluxes
+!--         rad_net_l is never used!           
+            rad_net_l(l)     = rad_net_l(l) + 3.0_wp * sigma_sb                         &
+                                * t_surf(l)**4 - 4.0_wp * sigma_sb                      &
+                                * t_surf(l)**3 * t_surf_p(l)
+            wghf_eb(l)       = lambda_surface * (t_surf_p(l) - t_wall(nzb_wall,l))
+
+!--         ground/wall/roof surface heat flux
+            wshf_eb(l)  = - f_shf  * ( pt1 - t_surf_p(l) )
+            
+!--         store kinematic surface heat fluxes for utilization in other processes
+!--         diffusion_s, surface_layer_fluxes,...
+            IF ( d == iroof )  THEN
+!--             shf is used in diffusion_s and also
+!--             for calculation of surface layer fluxes
+!--             update for horizontal surfaces
+                shf(j,i) = wshf_eb(l) / rho_cp
+            ELSE
+!--             surface heat flux for vertical surfaces
+!--             used in diffusion_s
+                wshf(l) = wshf_eb(l) / rho_cp
+            ENDIF
+
+        ENDDO
+        
+        
+        IF ( usm_anthropogenic_heat  .AND.  &
+             intermediate_timestep_count == intermediate_timestep_count_max )  THEN
+!--         application of the additional anthropogenic heat sources
+!--         we considere the traffic for now so all heat is absorbed
+!--         to the first layer, generalization would be worth
+            
+!--         calculation of actual profile coefficient
+!--         ??? check time_since_reference_point ???
+            dtime = mod(simulated_time + time_utc_init, 24.0_wp*3600.0_wp)
+            dhour = INT(dtime/3600.0_wp)
+!--         linear interpolation of coeficient
+            acoef = (REAL(dhour+1,wp)-dtime/3600.0_wp)*aheatprof(dhour) + (dtime/3600.0_wp-REAL(dhour,wp))*aheatprof(dhour+1)
+            DO i = nxl, nxr
+                DO j = nys, nyn
+                    IF ( aheat(j,i) > 0.0_wp )  THEN
+!--                     TODO the increase of pt in box i,j,nzb_s_inner(j,i)+1 in time dt_3d 
+!--                     given to anthropogenic heat aheat*acoef (W*m-2)
+!--                     k = nzb_s_inner(j,i)+1
+!--                     pt(k,j,i) = pt(k,j,i) + aheat(j,i)*acoef*dt_3d/(exn(k)*rho_cp*dz)
+!--                     Instead of this, we can adjust shf in case AH only at surface
+                        shf(j,i) = shf(j,i) + aheat(j,i)*acoef * ddx * ddy / rho_cp
+                    ENDIF
+                ENDDO
+            ENDDO
+        ENDIF
+        
+!--     pt and shf are defined on nxlg:nxrg,nysg:nyng
+!--     get the borders from neighbours
+        CALL exchange_horiz( pt, nbgp )
+        CALL exchange_horiz_2d( shf )
+
+
+!--    calculation of force_radiation_call:
+!--    Make logical OR for all processes.
+!--    Force radiation call if at least one processor forces it.
+       IF ( intermediate_timestep_count == intermediate_timestep_count_max-1 )          &
+       THEN
+#if defined( __parallel )
+          IF ( collective_wait )  CALL mpi_barrier( comm2d, ierr )
+              CALL mpi_allreduce( force_radiation_call_l, force_radiation_call,         &
+                                  1, MPI_LOGICAL, MPI_LOR, comm2d, ierr )
+#else
+          force_radiation_call = force_radiation_call_l
 #endif
-        ENDDO
-        
-    END SUBROUTINE usm_read_anthropogenic_heat
+          force_radiation_call_l = .FALSE.
+       ENDIF
+
+    END SUBROUTINE usm_surface_energy_balance
+
 
 !------------------------------------------------------------------------------!
